' converter

' Copyleft 2012 the Mojon Twins

#include "fbpng.bi"
#include "fbgfx.bi"
#include once "crt.bi"

#define RGBA_R( c ) ( CUInt( c ) Shr 16 And 255 )
#define RGBA_G( c ) ( CUInt( c ) Shr  8 And 255 )
#define RGBA_B( c ) ( CUInt( c )        And 255 )
#define RGBA_A( c ) ( CUInt( c ) Shr 24         )

Function detectSpeccyCol (colour as Integer) As Integer
	Dim As Integer result
	Dim As Integer r, g, b
	Dim As Integer rt, gt, bt
	
	r = RGBA_R (colour)
	g = RGBA_G (colour)
	b = RGBA_B (colour)
	
	If r > 128 Then rt = 1 Else rt = 0
	If g > 128 Then gt = 1 Else gt = 0
	If b > 128 Then bt = 1 Else bt = 0
	
	result = bt + rt * 2 + gt * 4
		
	Return result
End Function

Function detectBright (colour as Integer) As Integer
	Dim As Integer result
	Dim As Integer r, g, b
	
	r = RGBA_R (colour)
	g = RGBA_G (colour)
	b = RGBA_B (colour)
	
	If r > 200 Or g > 200 Or b > 200 Then
		result = 1
	Else
		result = 0
	End If
	
	Return result
End Function

Sub Usage () 
	Print "** USAGE **"
	Print "   24x24.exe input.png output.bas n_tiles"
	Print
	Print "Pretty please, use correct extensions."
	Print
	Print "EXPLANATION"
	Print "input.png - should be a 384 pixel wide PNG image. "
	Print "            Draw your picture using approximate speccy colours. "
	Print "            RGB<=200 will be BRIGHT 0"
	Print "            RGB >200 will be BRIGHT 1"
	Print "output.bin- A filename for your binary output, .bas will be added if omitted"
	Print "n_tiles   - # of tiles to convert (max = 256)."
	Print
End Sub

Dim as any ptr img 			' will contain the image loaded from the PNG
Dim as String filename 
Dim as String fileout
Dim as String codeout
Dim as Integer x, y, xx, yy, x1, y1, x0, y0, f, i, j, c1, c2, caux, b
Dim as uByte attribute
Dim as Integer nTiles
Dim As Byte Colours (2, 2), ink, paper, bright, rc1, rc2, by
Dim As Byte Inks (2, 2)
Dim As Byte Papers (2, 2)

If Len (Command (1)) = 0 Or Len (Command (2)) = 0 Then 
	Usage
	End
End If

If Len (Command (3)) = 0 Then
	nTiles = 256
Else
	nTiles = val (Command (3))
End If

' Primero cargo el archivo de imagen
screenres 640, 480, 32, , -1

filename = Command (1)
fileout = Command (2)

i = Instr (fileout, ".") 
If i <> 0 Then
	fileout = Left (fileout, i - 1)
End If

img = png_load ( filename )

if img then
'	put( 0, 0 ), img
'	deallocate( img )
else
	puts "Failed to load"
	End
end if

f = FreeFile

Open fileout + ".bas" For Output As #f

Print #f, ""
Print #f, "' Generated by 24x24 converter by the Mojon Twins"
Print #f, ""
Print #f, "Sub tileSet24x24container"
Print #f, "tileSet24x24:"
Print #f, "Asm"
Print #f, "tileset_24x24:"

x = 0: y = 0
For i = 1 To nTiles
	
	' First: Identify attributes and store
	For yy = 0 To 2
		For xx = 0 To 2
			
			' First Colour
			c1 = detectSpeccyCol (Point (x + xx * 8, y + yy * 8, img))
			c2 = 7
			b = 0
			
			' Find Second Colour
			For y0 = 0 To 7
				For x0 = 0 To 7
					' Bright
					if (b = 0) Then b = detectBright (Point (x + xx * 8 + x0, y + yy * 8 + y0, img))
			
					c2 = detectSpeccyCol (Point (x + xx * 8 + x0, y + yy * 8 + y0, img))
					If c2 <> c1 Then Exit For
				Next x0
				If c2 <> c1 Then Exit For
			Next y0
			
			' c1 = ink, always the biggest one:
			If c1 < c2 Then Swap c1, c2
			
			' Calculate attribute:
			Colours (yy, xx) = c2 * 8 + c1 + b * 64
			Inks (yy, xx) = c1
			Papers (yy, xx) = c2
			
	Next xx, yy

	' Now, on to the ordenation
	
	Print #f, "; Tile #" & Str (i - 1)
	codeout = "    defb "
	
	For y0 = 0 To 2
		For yy = 0 To 7	
			For x0 = 0 To 2
				by = 0
				For xx = 0 To 7
					' Extract bit pattern. If colours equals Inks (yy, xx) then it's a 1, 0 otherwise.
					c1 = detectSpeccyCol (Point (x + x0 * 8 + xx, y + y0 * 8 + yy, img))
					If c1 = Inks (y0, x0) Then by = by + 2 ^ (7 - xx)
				Next xx
				codeout = codeout & "$" & Hex (by, 2)
				If yy <> 7 Or y0 <> 2 Or x0 <> 2 Then codeout = codeout & ","
			Next x0
		Next yy
	Next y0
	
	Print #f, codeout
	
	' Attributes
	
	codeout = "    defb "
	For yy = 0 To 2
		For xx = 0 To 2
			codeout = codeout & "$" & Hex (Colours (yy, xx), 2)
			If yy <> 2 Or xx <> 2 Then codeout = codeout & ","
	Next xx, yy
	Print #f, codeout
	
	x = x + 24: If x = 384 Then x = 0: y = y + 24
Next i
Print #f, "End Asm"
Print #f, "End Sub"
Print #f, ""

Close #f
